import 'package:vid/us/vid_us_unit.dart';

import 'abstract.dart';

class SpeedMapCM extends UnitMapBase {
  SpeedMapCM() : super(VidUsUnit.cms);

  @override
  void initMap() {
    add(VidUsUnit.mms, 0.1);
    add(VidUsUnit.ms, 100);
  }
}

class SpeedMapMM extends UnitMapBase {
  SpeedMapMM() : super(VidUsUnit.mms);

  @override
  void initMap() {
    add(VidUsUnit.cms, 10);
    add(VidUsUnit.ms, 1000);
  }
}
