part of 'control_board.dart';

class _NextButton extends StatelessWidget {
  final playerController = Get.find<IPlayerController>() as VidPlayerController;
  @override
  Widget build(BuildContext context) {
    return IconButton(
      splashRadius: 2,
      padding: EdgeInsets.zero,
      onPressed: () {
        playerController.gotoNextFrame();
      },
      icon: const Icon(
        Icons.arrow_circle_right_outlined,
        color: Colors.white,
      ),
    );
  }
}
